{% extends 'base.html.twig' %}
{% block stylesheets %}
    {{ parent() }}
    <link rel="stylesheet" href="{{ asset('css/tv.css') }}">
    <link rel="stylesheet" href="{{ asset('dist/gauge/style.css') }}">
{% endblock %}

{% block body %}
	<div>
        <div class="row container-title d-flex align-items-center justify-content-center" style="background: url('{{ serie.wallpaper|tmdbImagePath }}') no-repeat">
            <div class="filter"></div>
            <h2>{{ serie.name }} ({{ serie.releaseDate|date('Y') }})</h2>
        </div>
        <div class="row description d-flex align-self-end justify-content-center align-items-center">
            <p>{{ serie.description.fr ?? serie.description.en }}</p>
        </div>
        <div class="row container-season">
            <div class="col-3 d-flex flex-column align-items-center">
                <div class="wrapper-poster">
                    <img class="poster" src="{{ serie.poster|tmdbImagePath }}">
                    <div class="wrapper-infos row d-flex flex-column align-items-center">
                        <div class="col-12 d-flex justify-content-between">
                            <p> {{ serie.name }}</p>
                            <p id="season_name"></p>
                        </div>
                        <div class="col-12 d-flex justify-content-between">
                            <p>Nb episodes : <span id="nb_episode"></span></p>
                            {% include 'watch/_gauge.html.twig' %}
                        </div>
                    </div>
                    <div class="wrapper-btn">
                        <button class="btn btn-secondary" data-action="follow">
                            <span class="fas fa-{{ followed is not empty ? 'check' : 'plus' }} mr-3"></span>
                            <span data-type="followed-text">{{ (followed is not empty ? 'followed' : 'follow')|trans }}</span>
                        </button>
                    </div>
                </div>
            </div>

            <div class="col-9 pt-4 d-flex flex-column align-items-center">
                <div class="row">
                    <select class="form-control" id="season_picker">
                        {% for id, name in seasons %}
                            <option value="{{ id }}" {% if id == season.season_number %}selected{% endif %}>{{ name }}</option>
                        {% endfor %}
                    </select>
                </div>
                <div class="row e-list" id="episodes">
                    {% include 'watch/_episodes.html.twig' with { 'episodes' : season.episodes } %}
                </div>
            </div>
        </div>

	</div>
{% endblock %}


{% block javascripts %}
    {{ parent() }}
    <script>
        $(document).ready(function() {

        	$('button[data-action="follow"]').click(function()
			{
				$.ajax({
					url: '{{ path('follow_toggle', {'tv': serie.id}) }}',
					type: 'GET',
					complete: function (result) {
						$('button[data-action="follow"] > span.fas')
							.removeClass (function (index, className) {
								return (className.match (/(^|\s)fa-\S+/g) || []).join(' ');
							})
							.addClass(result.responseJSON.followed ? 'fa-check' : 'fa-plus')
						;

						$('span[data-type="followed-text"]').text(result.responseJSON.followed ? trans.followed : trans.follow);
					}
				});
			});

        	$('#season_picker').change(function() {
        		let season = '{{ path('watch_season',{'id' : serie.id, 'season' : 'SEASON' }) }}';
        		season = season.replace('SEASON', $(this).val());
        		$.ajax({
                    url: season,
                    type: 'GET', // Le type de la requête HTTP.

                    complete: function (result) {
                        $('#episodes').html(result.responseJSON.html);
	                    changeSeasonInfos();
	                    refreshGauge();
                    }
        		});
        	});

	        var p = $('.wrapper-poster').offset().top - 90;

	        $(window).scroll(function(){
		        if($(this).scrollTop()>=p && $('.container-season').height() > 600 ){
			        $('.wrapper-poster').addClass('fixed');
		        } else {
			        $('.wrapper-poster').removeClass('fixed');
                }
	        });

	        changeSeasonInfos();
	        refreshGauge();

	        function changeSeasonInfos() {
		        $('#season_name').text($( "#season_picker option:selected" ).text());
		        $('#nb_episode').text($( "#season_infos" ).data('episodes'));
		        $('#gauge_text').text($( "#season_infos" ).data('vote') + ' / 10');
		        ($( "#season_infos" ).data('vote') !== "N/A" ? $('#gauge_text').text($( "#season_infos" ).data('vote') + ' / 10') : $('#gauge_text').text($( "#season_infos" ).data('vote')));
		        $('#progression_gauge').attr('data-target',($( "#season_infos" ).data('vote') * 10));
	        }

	        function refreshGauge(){
		        //SVG gauges script

		        var secondGauge = document.querySelector('.container:nth-of-type(1) .progress');
		        var secondTarget = parseInt(secondGauge.getAttribute('data-target'));

				//variables
		        var gaugeR = parseInt(document.querySelectorAll('circle')[0].getAttribute('r'));
		        var gaugeC = gaugeR * Math.PI * 2;
		        var animationDuration = 1.5;

				//init svg circles
		        var circles = document.querySelectorAll('circle');
		        var gauges = document.querySelectorAll('.progress');
		        TweenMax.set(circles, {
			        strokeDashoffset: gaugeC
		        });

		        TweenMax.set(gauges, {
			        attr: {
				        'stroke-dasharray': gaugeC + ' ' + gaugeC
			        }
		        });

				//calculate the offset
		        function calculateOffset(t, c) {

			        var target = c - (c * t) / 100;
			        return target;

		        }

				//timeline
		        var tl = new TimelineMax();

				//second gauge animation
		        tl.to(secondGauge, animationDuration, {

			        strokeDashoffset: calculateOffset(secondTarget, gaugeC),
			        ease: Power3.easeInOut

		        });
            }
        });
    </script>
{% endblock %}